% latex_term_pp.ml                                                            %
%-----------------------------------------------------------------------------%


let latex_term_rules =

   % : (print_rule list) %

   letrec is_right_assoc =
    (\dummy0. ((\meta. meta is_a_member_of
                          [`/\\`;`\\/`;`<=>`;`o`;`+`;`*`;`EXP`]
                ) dummy0))
   and is_an_infix =
    (\dummy0. ((\meta. apply1 is_infix (bound_name meta)) dummy0))
   and is_a_res_quan =
    (\dummy0. ((\meta. apply1 is_res_quan (bound_name meta)) dummy0))
   and is_a_binder =
    (\dummy0. ((\meta. apply1 is_binder (bound_name meta)) dummy0))
   and nullvarl =
    (\dummy0. ((\meta. apply1 null (bound_children meta)) dummy0))
   and prec = (\dummy0. ((bound_number `prec`) dummy0))
   and prec_of =
    (\dummy0. ((\meta. apply1 term_prec (bound_name meta)) dummy0))
   and prec_of_const = (\dummy0. ((\symb. apply0 (term_prec symb)) dummy0))
   and prec_test_metab =
    (\dummy0. ((\meta. apply2 (curry $>) (prec_of meta) prec) dummy0))
   and prec_test_meta =
    (\dummy0. ((\meta. apply2 (curry $<) (prec_of meta) prec) dummy0))
   and prec_test_const =
    (\dummy0. ((\symb. apply2 (curry $<) (prec_of_const symb) prec) dummy0))
   and prefix_sym =
    (\dummy0.
       ((             \symb. let prf = if ((is_infix symb) or (is_binder symb))
         			 then (`\\$`) else (``) in
                             (if (exists (\s. symb = s)
         			[`/\\`; `\\/`; `==>`; `<=>`; `*`; `~`; `!`; `?`] )
         			then (prf ^ symb_of(symb))
                             else (prf ^ `\\CONST{` ^ symb_of(symb) ^ `}`))
         )
         dummy0))
   in
   [
    ((`term`,
      (Const_name
        (`CONST`,[(Patt_child (Const_name (`NIL`,[])));Wild_children])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_constant `\\NIL `))])));
    ((`term`,(Const_name (`VAR`,[(Patt_child (Var_name (`var`,[])))])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_leaf (`var`,(dovar))))])));
    ((`term`,
      (Const_name
        (`VAR`,
         [(Patt_child (Var_name (`var`,[])));
          (Patt_child
            (Const_name (`type`,[(Patt_child (Var_child `type`))])))])),
      (\x y. true)),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const `:`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF
                 (HV_box
                   [(((Nat 0),(Abs 0),(Nat 0)),
                     (PO_leaf (`var`,(dovar))));
                    (((Nat 0),(Abs 0),(Nat 0)),
                     (PO_format
                       (PF
                         (H_box [((Nat 0),(PO_constant `:`));
                                 ((Nat 0),
                                  (PO_subcall ((`type`,(I)),[])))]))))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const `:`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,(Const_name (`CONST`,[(Patt_child (Var_name (`const`,[])))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_leaf (`const`,(prefix_sym))))])));
    ((`term`,
      (Const_name
        (`CONST`,
         [(Patt_child (Var_name (`const`,[])));
          (Patt_child
            (Const_name (`type`,[(Patt_child (Var_child `type`))])))])),
      (\x y. true)),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const `:`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF
                 (HV_box
                   [(((Nat 0),(Abs 0),(Nat 0)),
                     (PO_leaf (`const`,(prefix_sym))));
                    (((Nat 0),(Abs 0),(Nat 0)),
                     (PO_format
                       (PF
                         (H_box [((Nat 0),(PO_constant `:`));
                                 ((Nat 0),
                                  (PO_subcall ((`type`,(I)),[])))]))))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const `:`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,(Print_loop
               ((Const_name
                  (`COMB`,
                   [(Patt_child
                      (Const_name
                        (`COMB`,[(Patt_child
                                   (Const_name
                                     (`CONST`,[(Patt_child
                                                 (Var_name (`op`,[])));
                                               Wild_children])));
                                 (Patt_child (Var_child `comps`))])));
                    (Patt_child
                      (Link_child (((Val (Nat 1)),Default),[`op`])))])),
                (Var_child `comp`))),(`op` is_a_member_of [`,`])),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF (HV_box
                     [(((Nat 0),(Abs 0),(Nat 0)),
                       (PO_expand
                         (H_box [((Nat 0),
                                  (PO_subcall
                                    ((`comps`,(I)),
                                     [(`prec`,(prec_of `op`))])));
                                 ((Nat 0),(PO_leaf (`op`,(I))))])));
                      (((Nat 0),(Abs 0),(Nat 0)),
                       (PO_subcall
                         ((`comp`,(I)),[(`prec`,(prec_of `op`))])))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,(Print_loop
               ((Const_name
                  (`COMB`,
                   [(Patt_child
                      (Const_name
                        (`COMB`,[(Patt_child
                                   (Const_name
                                     (`CONST`,[(Patt_child
                                                 (Var_name (`op`,[])));
                                               Wild_children])));
                                 (Patt_child (Var_child `args`))])));
                    (Patt_child
                      (Link_child (((Val (Nat 1)),Default),[`op`])))])),
                (Var_child `arg`))),(`op` is_a_member_of [`EXP`])),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF (HoV_box
                     [(((Nat 1),(Abs 0),(Nat 0)),(PO_constant `(`));
                      (((Nat 1),(Abs 0),(Nat 0)),
                       (PO_expand
                         (HV_box
                           [(((Nat 1),(Abs 0),(Nat 0)),
                             (PO_subcall
                               ((`args`,(I)),
                                [(`prec`,(prec_of `op`))])));
                            (((Nat 1),(Abs 0),(Nat 0)),
                             (PO_constant `)\\:\\CONST{EXP}\\:(`))])));
                      (((Nat 1),(Abs 0),(Nat 0)),
                       (PO_subcall
                         ((`arg`,(I)),[(`prec`,(prec_of `op`))])));
                      (((Nat 1),(Abs 0),(Nat 0)),(PO_constant `)`))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,(Print_loop
               ((Const_name
                  (`COMB`,
                   [(Patt_child
                      (Const_name
                        (`COMB`,[(Patt_child
                                   (Const_name
                                     (`CONST`,[(Patt_child
                                                 (Var_name (`op`,[])));
                                               Wild_children])));
                                 (Patt_child (Var_child `args`))])));
                    (Patt_child
                      (Link_child (((Val (Nat 1)),Default),[`op`])))])),
                (Var_child `arg`))),(is_right_assoc `op`)),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF (HoV_box
                     [(((Nat 1),(Abs 0),(Nat 0)),
                       (PO_expand
                         (HV_box [(((Nat 1),(Abs 0),(Nat 0)),
                                   (PO_subcall
                                     ((`args`,(I)),
                                      [(`prec`,(prec_of `op`))])));
                                  (((Nat 1),(Abs 0),(Nat 0)),
                                   (PO_leaf (`op`,(symb_of))))])));
                      (((Nat 1),(Abs 0),(Nat 0)),
                       (PO_subcall
                         ((`arg`,(I)),[(`prec`,(prec_of `op`))])))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,
      (Const_name
        (`COMB`,[(Patt_child
                   (Const_name
                     (`COMB`,[(Patt_child
                                (Const_name
                                  (`CONST`,
                                   [(Patt_child (Var_name (`op`,[])));
                                    Wild_children])));
                              (Patt_child (Var_child `arg1`))])));
                 (Patt_child (Var_child `arg2`))])),(is_an_infix `op`)),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF (HV_box
                     [(((Nat 1),(Abs 3),(Nat 0)),
                       (PO_format
                         (PF
                           (H_box
                             [((Nat 1),
                               (PO_subcall
                                 ((`arg1`,(I)),
                                  [(`prec`,(prec_of `op`))])));
                              ((Nat 1),(PO_leaf (`op`,(doinfix))))]))));
                      (((Nat 1),(Abs 3),(Nat 0)),
                       (PO_subcall
                         ((`arg2`,(I)),[(`prec`,(prec_of `op`))])))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,(Const_name
               (`COMB`,
                [(Patt_child
                   (Const_name
                     (`CONST`,
                      [(Patt_child (Var_name (`op`,[])));Wild_children])));
                 (Patt_child (Var_child `arg`))])),
      (`op` is_a_member_of [`~`])),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),(PO_leaf (`op`,(symb_of))));
            ((Nat 0),(PO_subcall ((`arg`,(I)),[(`prec`,(prec_of `op`))])));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_meta `op`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,
      (Print_loop
        ((Const_name
           (`COMB`,
            [(Patt_child
               (Const_name
                 (`COMB`,[(Patt_child
                            (Const_name
                              (`CONST`,[(Patt_child
                                          (Var_name (`op`,[])));
                                        Wild_children])));
                          (Patt_child (Var_child `pred`))])));
             (Patt_child
               (Const_name
                 (`ABS`,
                  [(Patt_child (Var_child `bvs`));
                   (Patt_child
                     (Link_child
                       (((Val (Nat 1)),Default),[`op`;`pred`])))])))])),
         (Var_child `body`))),(is_a_res_quan `op`)),
     [(`bv`,(new_children (\x. [hd x]) `bvs`));
      (`bvs`,(new_children tl `bvs`))],
     (PF
       (H_box
         [((Nat 0),
           (PO_format
             (PF_branch
               ((prec_test_metab `op`),
                (PF (H_box [((Nat 0),(PO_constant `(`))])),PF_empty))));
          ((Nat 0),
           (PO_format
             (PF
               (HV_box
                 [(((Nat 1),(Abs 3),(Nat 0)),
                   (PO_format
                     (PF
                       (H_box
                         [((Nat 0),
                           (PO_leaf (`op`,(symb_of))));
                          ((Nat 0),
                           (PO_format
                             (PF
                               (H_box
                                 [((Nat 1),
                                   (PO_subcall
                                     ((`bv`,(I)),[])));
                                  ((Nat 1),
                                   (PO_format
                                     (PF_branch
                                       ((nullvarl `bvs`),
                                        PF_empty,
                                        (PF
                                          (H_box
                                            [((Nat
                                                1),
                                              (PO_expand
                                                (H_box
                                                  [((Nat
                                                      0),
                                                    (PO_constant
                                                      `\\,`));
                                                   ((Nat
                                                      0),
                                                    (PO_subcall
                                                      ((`bvs`,
                                                        (I)),
                                                       [(`prec`,
                                                         (apply0 min_term_prec))])))])))]))))))]))));
                          ((Nat 0),(PO_constant `\\RESDOT `));
                          ((Nat 0),
                           (PO_format
                             (PF
                               (H_box
                                 [((Nat 1),
                                   (PO_subcall
                                     ((`pred`,(I)),
                                      [(`prec`,
                                        (prec_of `op`))])))]))));
                          ((Nat 0),(PO_constant `\\DOT`))]))));
                  (((Nat 1),(Abs 3),(Nat 0)),
                   (PO_subcall
                     ((`body`,(I)),[(`prec`,(prec_of `op`))])))]))));
          ((Nat 0),
           (PO_format
             (PF_branch
               ((prec_test_metab `op`),
                (PF (H_box [((Nat 0),(PO_constant `)`))])),PF_empty))))])));
    ((`term`,
      (Print_loop
        ((Const_name
           (`COMB`,
            [(Patt_child
               (Const_name
                 (`CONST`,[(Patt_child (Var_name (`op`,[])));
                           Wild_children])));
             (Patt_child
               (Const_name
                 (`ABS`,[(Patt_child (Var_child `bvs`));
                         (Patt_child
                           (Link_child
                             (((Val (Nat 1)),Default),[`op`])))])))])),
         (Var_child `body`))),(is_a_binder `op`)),
     [(`bv`,(new_children (\x. [hd x]) `bvs`));
      (`bvs`,(new_children tl `bvs`))],
     (PF
       (H_box
         [((Nat 0),
           (PO_format
             (PF_branch
               ((prec_test_metab `op`),
                (PF (H_box [((Nat 0),(PO_constant `(`))])),PF_empty))));
          ((Nat 0),
           (PO_format
             (PF
               (HV_box
                 [(((Nat 1),(Abs 3),(Nat 0)),
                   (PO_format
                     (PF
                       (H_box
                         [((Nat 0),
                           (PO_leaf (`op`,(symb_of))));
                          ((Nat 0),
                           (PO_format
                             (PF
                               (H_box
                                 [((Nat 1),
                                   (PO_subcall
                                     ((`bv`,(I)),[])));
                                  ((Nat 1),
                                   (PO_format
                                     (PF_branch
                                       ((nullvarl `bvs`),
                                        PF_empty,
                                        (PF
                                          (H_box
                                            [((Nat
                                                1),
                                              (PO_expand
                                                (H_box
                                                  [((Nat
                                                      0),
                                                    (PO_constant
                                                      `\\,`));
                                                   ((Nat
                                                      0),
                                                    (PO_subcall
                                                      ((`bvs`,
                                                        (I)),
                                                       [(`prec`,
                                                         (apply0 min_term_prec))])))])))]))))))]))));
                          ((Nat 0),(PO_constant `\\DOT`))]))));
                  (((Nat 1),(Abs 3),(Nat 0)),
                   (PO_subcall
                     ((`body`,(I)),[(`prec`,(prec_of `op`))])))]))));
          ((Nat 0),
           (PO_format
             (PF_branch
               ((prec_test_metab `op`),
                (PF (H_box [((Nat 0),(PO_constant `)`))])),PF_empty))))])));
    ((`term`,
      (Print_loop
        ((Const_name
           (`ABS`,
            [(Patt_child (Var_child `bvs`));
             (Patt_child
               (Print_link (((Default,Default),[]),
                            (Const_name (`ABS`,[Wild_children])))))])),
         (Const_name (`ABS`,[(Patt_child (Var_child `bv`));
                             (Patt_child (Var_child `body`))])))),
      (\x y. true)),[],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const `\\`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF
                 (HV_box
                   [(((Nat 1),(Abs 3),(Nat 0)),
                     (PO_format
                       (PF
                         (H_box
                           [((Nat 1),(PO_constant `\\LAMBDA`));
                            ((Nat 1),
                             (PO_format
                               (PF
                                 (H_box
                                   [((Nat 1),
                                     (PO_expand
                                       (H_box
                                         [((Nat 1),
                                           (PO_subcall
                                             ((`bvs`,
                                               (I)),
                                              [(`prec`,
                                                (apply0 min_term_prec))])));
                                          ((Nat 1),
                                           (PO_constant
                                             `\\,`))])))]))));
                            ((Nat 1),
                             (PO_subcall ((`bv`,(I)),[])));
                            ((Nat 1),(PO_constant `\\DOT`))]))));
                    (((Nat 1),(Abs 3),(Nat 0)),
                     (PO_subcall ((`body`,(I)),
                                  [(`prec`,(prec_of_const `\\`))])))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const `\\`),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,
      (Const_name
        (`COMB`,[(Patt_child
                   (Const_name
                     (`COMB`,[(Patt_child
                                (Const_name
                                  (`COMB`,
                                   [(Patt_child
                                      (Const_name
                                        (`CONST`,
                                         [(Patt_child
                                            (Const_name (`COND`,[])));
                                          Wild_children])));
                                    (Patt_child (Var_child `cond`))])));
                              (Patt_child (Var_child `x`))])));
                 (Patt_child (Var_child `y`))])),(\x y. true)),[],
     (PF (H_box
           [((Nat 0),(PO_constant `(`));
            ((Nat 0),
             (PO_format
               (PF
                 (HoV_box
                   [(((Nat 1),(Abs 0),(Nat 0)),
                     (PO_format
                       (PF (HV_box
                             [(((Nat 1),(Abs 0),(Nat 0)),
                               (PO_subcall
                                 ((`cond`,(I)),
                                  [(`prec`,
                                    (prec_of_const `COND`))])));
                              (((Nat 1),(Abs 0),(Nat 0)),
                               (PO_constant `\\Rightarrow `))]))));
                    (((Nat 1),(Abs 0),(Nat 0)),
                     (PO_format
                       (PF (HV_box
                             [(((Nat 1),(Abs 0),(Nat 0)),
                               (PO_subcall
                                 ((`x`,(I)),
                                  [(`prec`,
                                    (prec_of_const `COND`))])));
                              (((Nat 1),(Abs 0),(Nat 0)),
                               (PO_constant `\\mid `))]))));
                    (((Nat 1),(Abs 0),(Nat 0)),
                     (PO_subcall
                       ((`y`,(I)),[(`prec`,(prec_of_const `COND`))])))]))));
            ((Nat 0),(PO_constant `)`))])));
    ((`term_let`,
      (Print_loop
        ((Const_name
           (`ABS`,[(Patt_child (Var_child `args`));
                   (Patt_child (Link_child ((Default,Default),[])))])),
         Wild_child)),(\x y. true)),[],
     (PF (H_box [((Nat 1),(PO_context_subcall (`term`,(`args`,(I)),[])))])));
    ((`term`,(Print_loop
               ((Const_name
                  (`COMB`,
                   [(Patt_child
                      (Const_name
                        (`COMB`,
                         [(Patt_child
                            (Const_name
                              (`CONST`,
                               [(Patt_child
                                  (Const_name (`LET`,[])));
                                Wild_children])));
                          (Patt_child
                            (Print_link
                              (((Default,Default),[]),
                               (Const_name
                                 (`COMB`,
                                  [(Patt_child
                                     (Const_name
                                       (`COMB`,
                                        [(Patt_child
                                           (Const_name
                                             (`CONST`,
                                              [(Patt_child
                                                 (Const_name
                                                   (`LET`,
                                                    [])));
                                               Wild_children])));
                                         (Patt_child
                                           Wild_child)])));
                                   (Patt_child Wild_child)])))))])));
                    (Patt_child
                      (Print_label
                        (`argsl`,
                         (Print_loop
                           ((Const_name
                              (`ABS`,[(Patt_child Wild_child);
                                      (Patt_child
                                        (Link_child
                                          ((Default,Default),[])))])),
                            (Var_child `letbodyl`))))))])),
                (Const_name
                  (`COMB`,
                   [(Patt_child
                      (Const_name
                        (`COMB`,
                         [(Patt_child
                            (Const_name
                              (`CONST`,[(Patt_child
                                          (Const_name (`LET`,[])));
                                        Wild_children])));
                          (Patt_child
                            (Const_name
                              (`ABS`,[(Patt_child (Var_child `bv`));
                                      (Patt_child
                                        (Print_loop
                                          ((Const_name
                                             (`ABS`,
                                              [(Patt_child
                                                 (Var_child
                                                   `bvl`));
                                               (Patt_child
                                                 (Link_child
                                                   ((Default,
                                                     Default),
                                                    [])))])),
                                           (Var_child `body`))))])))])));
                    (Patt_child
                      (Print_label
                        (`args`,
                         (Print_loop
                           ((Const_name
                              (`ABS`,[(Patt_child Wild_child);
                                      (Patt_child
                                        (Link_child
                                          ((Default,Default),[])))])),
                            (Var_child `letbody`))))))])))),
      (apply2 (\x y. length x = length y)
                 (bound_children `bvl`)
                    (bound_children `argsl`)
       )),[(`argsl`,(new_children rev `argsl`));
           (`letbodyl`,(new_children rev `letbodyl`))],
     (PF
       (H_box
         [((Nat 0),
           (PO_format
             (PF_branch ((prec_test_const `LET`),PF_empty,
                         (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
          ((Nat 0),
           (PO_format
             (PF
               (HoV_box
                 [(((Nat 1),(Abs 0),(Nat 0)),
                   (PO_format
                     (PF
                       (HV_box
                         [(((Nat 1),(Abs 1),(Nat 0)),
                           (PO_format
                             (PF
                               (H_box
                                 [((Nat 1),
                                   (PO_constant
                                     `\\KEYWD{let}\\;`));
                                  ((Nat 1),
                                   (PO_subcall
                                     ((`bv`,(I)),
                                      [(`prec`,
                                        (apply0 min_term_prec))])));
                                  ((Nat 1),
                                   (PO_context_subcall
                                     (`term_let`,
                                      (`args`,(I)),
                                      [(`prec`,
                                        (apply0 min_term_prec))])));
                                  ((Nat 1),
                                   (PO_constant `=`))]))));
                          (((Nat 1),(Abs 1),(Nat 0)),
                           (PO_subcall
                             ((`letbody`,(I)),
                              [(`prec`,
                                (prec_of_const `LET`))])))]))));
                  (((Nat 1),(Abs 0),(Nat 0)),
                   (PO_expand
                     (HV_box
                       [(((Nat 1),(Abs 1),(Nat 0)),
                         (PO_expand
                           (HV_box
                             [(((Nat 1),(Abs 0),
                                (Nat 0)),
                               (PO_constant
                                 `\\;\\KEYWD{and}`));
                              (((Nat 1),(Abs 0),
                                (Nat 0)),
                               (PO_subcall
                                 ((`bvl`,(I)),
                                  [(`prec`,
                                    (apply0 min_term_prec))])));
                              (((Nat 1),(Abs 0),
                                (Nat 0)),
                               (PO_context_subcall
                                 (`term_let`,
                                  (`argsl`,(I)),
                                  [(`prec`,
                                    (apply0 min_term_prec))])));
                              (((Nat 1),(Abs 0),(Nat 0)),
                               (PO_constant `=`))])));
                        (((Nat 1),(Abs 1),(Nat 0)),
                         (PO_subcall
                           ((`letbodyl`,(I)),
                            [(`prec`,(prec_of_const `LET`))])))])));
                  (((Nat 1),(Abs 0),(Nat 0)),
                   (PO_format
                     (PF
                       (V_box
                         [(((Abs 0),(Nat 0)),
                           (PO_constant `\\;\\KEYWD{in}`));
                          (((Abs 0),(Nat 0)),
                           (PO_format
                             (PF
                               (HV_box
                                 [(((Nat 1),(Abs 0),
                                    (Nat 0)),
                                   (PO_subcall
                                     ((`body`,(I)),
                                      [(`prec`,
                                        (prec_of_const `LET`))])))]))))]))))]))));
          ((Nat 0),
           (PO_format
             (PF_branch ((prec_test_const `LET`),PF_empty,
                         (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,
      (Print_loop
        ((Const_name
           (`COMB`,
            [(Patt_child
               (Const_name
                 (`COMB`,[(Patt_child
                            (Const_name
                              (`CONST`,
                               [(Patt_child
                                  (Const_name (`CONS`,[])));
                                Wild_children])));
                          (Patt_child (Var_child `elems`))])));
             (Patt_child
               (Print_link (((Default,Default),[]),
                            (Const_name (`COMB`,[Wild_children])))))])),
         (Const_name
           (`COMB`,
            [(Patt_child
               (Const_name
                 (`COMB`,[(Patt_child
                            (Const_name
                              (`CONST`,
                               [(Patt_child
                                  (Const_name (`CONS`,[])));
                                Wild_children])));
                          (Patt_child (Var_child `elem`))])));
             (Patt_child
               (Const_name
                 (`CONST`,[(Patt_child (Const_name (`NIL`,[])));
                           Wild_children])))])))),(\x y. true)),[],
     (PF (H_box
           [((Nat 0),(PO_constant `[`));
            ((Nat 0),
             (PO_format
               (PF
                 (HoV_box
                   [(((Nat 0),(Abs 0),(Nat 0)),
                     (PO_expand
                       (H_box [((Nat 0),
                                (PO_subcall
                                  ((`elems`,(I)),
                                   [(`prec`,
                                     (apply0 max_term_prec))])));
                               ((Nat 0),(PO_constant `;`))])));
                    (((Nat 0),(Abs 0),(Nat 0)),
                     (PO_subcall ((`elem`,(I)),
                                  [(`prec`,(apply0 max_term_prec))])))]))));
            ((Nat 0),(PO_constant `]`))])));
    ((`term`,
      (Print_loop
        ((Const_name
           (`COMB`,
            [(Patt_child (Link_child (((Val (Nat 1)),Default),[])));
             (Patt_child (Var_child `rands`))])),(Var_child `rator`))),
      (\x y. true)),[(`rands`,(new_children rev `rands`))],
     (PF (H_box
           [((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const ``),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `(`))]))))));
            ((Nat 0),
             (PO_format
               (PF (HV_box
                     [(((Nat 1),(Abs 3),(Nat 0)),
                       (PO_subcall ((`rator`,(I)),
                                    [(`prec`,(prec_of_const ``))])));
                      (((Nat 1),(Abs 3),(Nat 0)),
                       (PO_expand
                         (H_box
                           [((Nat 0),(PO_constant `\\,`));
                            ((Nat 0),
                             (PO_subcall
                               ((`rands`,(I)),
                                [(`prec`,(prec_of_const ``))])))])))]))));
            ((Nat 0),
             (PO_format
               (PF_branch ((prec_test_const ``),PF_empty,
                           (PF (H_box [((Nat 0),(PO_constant `)`))]))))))])));
    ((`term`,(Const_name (`term`,[(Patt_child (Var_child `term`))])),
      (\x y. true)),[],
     (PF (H_box
           [((Nat 0),(PO_constant `"`));
            ((Nat 0),
             (PO_subcall ((`term`,(I)),[(`prec`,(apply0 max_term_prec))])));
            ((Nat 0),(PO_constant `"`))])));
    ((`thm`,(Var_child `term`),(\x y. true)),[],
     (PF (H_box
           [((Nat 0),
             (PO_context_subcall
               (`term`,(`term`,(I)),[(`prec`,(apply0 max_term_prec))])))])))
   ] : print_rule list;;


let latex_term_rules_fun =

   % : (print_rule_function) %

   print_rule_fun latex_term_rules;;


%-----------------------------------------------------------------------------%
